function loadXHRInterceptor(){
    call_native("loadXHRInterceptor start");
    var _XMLHttpRequest = window.XMLHttpRequest;
    var XMLHttpRequest = function (){
        var xhr = new _XMLHttpRequest();
        xhr.onreadystatechange = function(){
            /*call_native('');*/
            if(this.readyState != 4) return;
            var type = typeof this.xhr.responseText;
            call_native({"call_type":"readyStateChange", "parames":{"url":this.url, "response":JSON.stringify({type:type, text:this.xhr.response}) }});
            return this.onreadystatechange && this.onreadystatechange.apply(this, arguments);
        }.bind(this);
        xhr.onloadstart = function(){
            /*call_native('');*/
            return this.onloadstart && this.onloadstart.apply(this, arguments);
        }.bind(this);
        xhr.onprogress = function(){
            /*call_native('');*/
            return this.onprogress && this.onprogress.apply(this, arguments);
        }.bind(this);
        xhr.onabort = function(){
            /*call_native('');*/
            return this.onabort && this.onabort.apply(this, arguments);
        }.bind(this);
        xhr.onerror = function(){
            /*call_native('');*/
            return this.onerror && this.onerror.apply(this, arguments);
        }.bind(this);
        xhr.onload = function(){
            /*call_native('');*/
            return this.onload && this.onload.apply(this, arguments);
        }.bind(this);
        xhr.ontimeout = function(){
            /*call_native('');*/
            return this.ontimeout && this.ontimeout.apply(this, arguments);
        }.bind(this);
        xhr.onloadend = function(){
            /*call_native('');*/
            return this.onloadend && this.onloadend.apply(this, arguments);
        }.bind(this);

        this.xhr = xhr;
        this.url = '';
        this.onreadystatechange = null;
        this.onloadstart = null;
        this.onprogress = null;
        this.onabort = null;
        this.onerror = null;
        this.onload  = null;
        this.ontimeout = null;
        this.onloadend = null;
    };
    XMLHttpRequest.prototype = {
        DONE : 4,
        HEADERS_RECEIVED : 2,
        LOADDING : 3,
        OPENED : 1,
        UNSENT : 0,
        constructor : XMLHttpRequest,
        open : function(){
            this.url = arguments[1] || '';
            return this.xhr.open.apply(this.xhr, arguments);
        },
        send : function(){
            return this.xhr.send.apply(this.xhr, arguments);
        },
        abort : function(){
            return this.xhr.abort.apply(this.xhr, arguments);
        },
        getAllResponseHeaders : function(){
            return this.xhr.getAllResponseHeaders.apply(this.xhr, arguments);
        },
        getResponseHeader : function(){
            return this.xhr.getResponseHeader.apply(this.xhr, arguments);
        },
        overrideMimeType : function(){
            return this.xhr.overrideMimeType.apply(this.xhr, arguments);
        },
        setRequestHeader : function(){
            return this.xhr.setRequestHeader.apply(this.xhr, arguments);
        },
        get readyState(){
            return this.xhr.readyState;
        },
        get response(){
            return this.xhr.response;
        },
        get responseText(){
            return this.xhr.responseText;
        },
        get responseType(){
            return this.xhr.responseType;
        },
        get responseXML(){
            return this.xhr.responseXML;
        },
        get status(){
            return this.xhr.status;
        },
        get statusText(){
            return this.xhr.statusText;
        },
        get upload(){
            return this.xhr.upload;
        },
        get withCredentials(){
            return this.xhr.withCredentials;
        },
        get channel(){
            return this.xhr.channel;
        },
        get mozBackgroundRequest(){
            return this.xhr.mozBackgroundRequest;
        },
        get multipart(){
            return this.xhr.multipart;
        },
        get timeout(){
            return this.xhr.timeout;
        },
        set responseType(type){
            this.xhr.responseType = type;
        },
        set withCredentials( isWithCredentials ){
            this.xhr.withCredentials = isWithCredentials;
        },
        set mozBackgroundRequest( isMozBackgroundRequest ){
            this.xhr.mozBackgroundRequest = isMozBackgroundRequest;
        },
        set multipart( isMultipart ){
            this.xhr.multipart = isMultipart;
        },
        set timeout( timeout ){
            this.xhr.timeout = timeout;
        }
    };
    window.XMLHttpRequest = XMLHttpRequest;
    call_native("loadXHRInterceptor end");
}

function loadJsonpInterceptor( get_data_by_jsonp ){
   call_native({"call_type":"readyStateChange", "parames":{"url":'errlog', "response":'enter json-interceptor'}});

    var MutationObserver = window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver;
    if( !MutationObserver ){
        call_native({"call_type":"readyStateChange", "parames":{"url":'errlog', "response":'no MutationObserver'}});
        return;
    }
    var rootElem = document.getElementsByTagName('html')[0];
    if( !rootElem ){
        call_native({"call_type":"readyStateChange", "parames":{"url":'errlog', "response":'html not ready' }});
        return;
    }
    call_native({"call_type":"readyStateChange", "parames":{"url":'errlog', "response":'json-interceptor ready'}});

    var scripts = document.getElementsByTagName('script');
    if( scripts ){
      $.each(scripts, function(i, script){
          ajax(script.src, get_data_by_jsonp);
      });
    }

    var ob = new MutationObserver(
                              function(mutations){
                                  $.each(mutations,function(i, mutation){
                                      if( mutation.attributeName === 'src' ){
                                              ajax(mutation.target.src, get_data_by_jsonp);
                                      }else if( mutation.addedNodes ){
                                         $.each(mutation.addedNodes, function(i, node){
                                                if( !node || (node.tagName||'').toUpperCase() !== 'SCRIPT' ){
                                                return true;
                                                }
                                                $(node).on('load', function(){
                                                      ajax(this.src, get_data_by_jsonp);
                                                  });
                                          });
                                      }
                                  });
                              });
    ob.observe(rootElem, {
               childList : true,
               subtree : true,
               attributes: true,
               attributeFilter: ['src']
               });

    function ajax(src, get_data_by_jsonp){
        if( !src ){
          return;
       }

       if( !get_data_by_jsonp ){
         $.ajax({
              url: src,
              type: 'GET',
              dataType: 'text',
              async: true,
              cache: true,
          });
       }else if( !/(\?|&)callback=[^&]*hZMz\d+(?=&|$)/.test(src) ){
         var jsonpCallback = '';
         src = src.replace(/(\?|&)callback=(.*?)(?=&|$)/i, function(a,b,c){
                         jsonpCallback = c;
                         return b + 'callback=??';
                         });
       jsonpCallback += 'hZMz' + (new Date()).getTime();
       $.ajax({
              url: src,
              type: 'GET',
              dataType: 'jsonp',
              jsonpCallback: jsonpCallback,
              async: true,
              cache: true,
              success: function(jsonp){
              console.log(jsonp);
              console.log('call_native');
              /*call_native('');*/
              },
              error: function(){
              /*call_native('');*/
              },
              complete: function(){
              /*call_native('');*/
              }
        });
       }
    }
}

function call_native (parames) {
       var jsonStr =  JSON.stringify(parames);
       window.android.postMessageXhr(jsonStr);
}

loadXHRInterceptor();
call_native({"call_type":"readyStateChange", "parames":{"url":'errlog', "response":'calling json-interceptor'}});
loadJsonpInterceptor();

function test1(){
var body = document.getElementsByTagName('body')[0];
var div = document.createElement('div');
div.innerHTML = 'aaaa';
body.appendChild(div);
}
test1();
